*+====================================================================
*+
*+    Source Module => F:\DBF_Y2K\PROGRESS.PRG
*+
*+    A Year 2000 date scanning project by Phil Barnett and Ross McKenzie
*+    
*+    DBF_Y2K is Public Domain and complete Source Code is provided.
*+
*+    Functions: Procedure PROGRESS()
*+               Procedure INIT_PROGRESS()
*+               Procedure KILL_PROGRESS()
*+
*+    Reformatted by Click! 1.12 on Dec-1-1997 at 11:43 pm
*+
*+====================================================================

#include "COMMON.CH"

static aData := {,,,,, .f.,, }

#define LAST_REC aData[ 1 ]
#define ONE_PART aData[ 2 ]
#define METER_LINE aData[ 3 ]
#define REC_NO aData[ 4 ]
#define INVIDEO aData[ 5 ]
#define ACTIVE aData[ 6 ]
#define LAST_ONE aData[ 7 ]
#define TOGGLE aData[ 8 ]

*+--------------------------------------------------------------------
*+
*+    Procedure PROGRESS()
*+
*+    Called from ( dbf_y2k.prg  )   1 - procedure dbf_y2k()
*+
*+--------------------------------------------------------------------
*+
procedure PROGRESS()

if ACTIVE

   REC_NO ++

   do case
   case LAST_REC > 100
      if REC_NO % ONE_PART == 0 .or. REC_NO == LAST_REC
         if LAST_ONE <> int( ( REC_NO / LAST_REC ) * 49 )
            TOGGLE := .t.
         endif
         if TOGGLE
            @ METER_LINE, 15 + ( ( REC_NO / LAST_REC ) * 49 ) say '' color 'GB+/W'        
            TOGGLE := .f.
         else
            @ METER_LINE, 15 + ( ( REC_NO / LAST_REC ) * 49 ) say '' color 'GB+/W'        
         endif
         LAST_ONE := int( ( REC_NO / LAST_REC ) * 49 )
      endif
   case LAST_REC > 50
      if REC_NO % ONE_PART == 0 .or. REC_NO == LAST_REC
         @ METER_LINE, 15 + ( ( REC_NO / LAST_REC ) * 49 ) say '' color 'GB+/W'        
      endif
   otherwise
      if LAST_REC > 2
         @ METER_LINE, 15 say replicate( '', min( ( REC_NO / LAST_REC ) * 50, 50 ) ) color 'GB+/W'        
      else
         @ METER_LINE, 15 say replicate( '', 50 ) color 'GB+/W'        
      endif
   endcase

endif

return

*+--------------------------------------------------------------------
*+
*+    Procedure INIT_PROGRESS()
*+
*+    Called from ( dbf_y2k.prg  )   1 - procedure dbf_y2k()
*+
*+--------------------------------------------------------------------
*+
procedure INIT_PROGRESS( LINE_NO, TOT_COUNT, title )

local INCOLOR := setcolor()

TOGGLE := .t.

METER_LINE := LINE_NO

INVIDEO := savescreen( LINE_NO - 2, 13, LINE_NO + 1, 66 )

setcolor( 'N/W,GR+/R,,,W/N' )
dispbox( LINE_NO - 2, 13, LINE_NO + 1, 66 )
setcolor( 'B/W,W+/B,,,W+/N' )
@ LINE_NO - 1, 14 say ' 0 . . . . . . . . . . .50. . . . . . . . . . . 100 '                       
@ LINE_NO, 14     say space( 52 )                                                                  
@ METER_LINE, 15  say ''                                                    color 'GB+/GR'        
if !empty( title )
   attention( title, LINE_NO - 2, "N/W" )
endif

REC_NO := - 1

LAST_REC := TOT_COUNT

if LAST_REC > 99
   ONE_PART := int( LAST_REC / 99 )
else
   ONE_PART := int( LAST_REC / 48 )
endif

setcolor( INCOLOR )

ACTIVE := .t.

return

*+--------------------------------------------------------------------
*+
*+    Procedure KILL_PROGRESS()
*+
*+    Called from ( dbf_y2k.prg  )   1 - procedure dbf_y2k()
*+
*+--------------------------------------------------------------------
*+
procedure KILL_PROGRESS()

restscreen( METER_LINE - 2, 13, METER_LINE + 1, 66, INVIDEO )

ACTIVE := .f.

return

*+ EOF: PROGRESS.PRG
